#include "mainwindow.h"
#include "ui_mainwindow.h"

#include <iostream>
#include <QMessageBox>

#include <QSqlDatabase>
#include <QSqlError>
#include <QSqlQuery>
#include <QSqlRecord>

#include <QtSql>
#include <QDataWidgetMapper>

QSqlDatabase DB;                     // ݿ
QSqlTableModel *tabModel;            // ģ
QItemSelectionModel *theSelection;   // ѡģ
QDataWidgetMapper *dataMapper;       // ӳ

void MainWindow::InitSQL()
{
    QSqlDatabase db = QSqlDatabase::addDatabase("QSQLITE");
    db.setDatabaseName("./database.db");
     if (!db.open())
     {
            return;
     }

    // ִSQL
    db.exec("DROP TABLE Student");
    db.exec("CREATE TABLE Student ("
                    "id INTEGER PRIMARY KEY AUTOINCREMENT, "
                    "name VARCHAR(40) NOT NULL, "
                    "sex VARCHAR(40) NOT NULL, "
                    "age INTEGER NOT NULL,"
                    "mobile VARCHAR(40) NOT NULL,"
                    "city VARCHAR(40) NOT NULL)"
         );

    // 
    db.exec("INSERT INTO Student(name,sex,age,mobile,city) ""VALUES ('zhangsan','M','25','1234567890','beijing')");
    db.exec("INSERT INTO Student(name,sex,age,mobile,city) ""VALUES ('lisi','X','22','4567890987','shanghai')");
    db.exec("INSERT INTO Student(name,sex,age,mobile,city) ""VALUES ('wangwu','X','18','224589654','beijing')");
    db.exec("INSERT INTO Student(name,sex,age,mobile,city) VALUES ('zhaoliu','M','28','9876543210','shandong')");
    db.exec("INSERT INTO Student(name,sex,age,mobile,city) VALUES ('sunqi','M','20','1122334455','tianjin')");
    db.exec("INSERT INTO Student(name,sex,age,mobile,city) VALUES ('zhoujiu','M','30','8765432109','jinan')");
    db.exec("INSERT INTO Student(name,sex,age,mobile,city) VALUES ('liushi','X','26','3344556677','zibo')");
}

MainWindow::MainWindow(QWidget *parent) :QMainWindow(parent),ui(new Ui::MainWindow)
{
    ui->setupUi(this);

    InitSQL();

    // ݿ
    DB=QSqlDatabase::addDatabase("QSQLITE"); //  SQL LITEݿ
    DB.setDatabaseName("./database.db");     // ݿ
    if (!DB.open())
    {
        return;
    }

    // ݱ
    tabModel=new QSqlTableModel(this,DB);                             // ݱ
    tabModel->setTable("Student");                                    // ݱ
    tabModel->setEditStrategy(QSqlTableModel::OnManualSubmit);        // ݱ淽ʽOnManualSubmit , OnRowChange
    tabModel->setSort(tabModel->fieldIndex("id"),Qt::AscendingOrder); // 
    if (!(tabModel->select()))                                        // ѯ
    {
       return;
    }

    // ֶ
    tabModel->setHeaderData(tabModel->fieldIndex("id"),Qt::Horizontal,"Uid");
    tabModel->setHeaderData(tabModel->fieldIndex("name"),Qt::Horizontal,"Uname");
    tabModel->setHeaderData(tabModel->fieldIndex("sex"),Qt::Horizontal,"Usex");
    tabModel->setHeaderData(tabModel->fieldIndex("age"),Qt::Horizontal,"Uage");
    tabModel->setHeaderData(tabModel->fieldIndex("mobile"),Qt::Horizontal,"Umobile");
    tabModel->setHeaderData(tabModel->fieldIndex("city"),Qt::Horizontal,"Ucity");

    theSelection=new QItemSelectionModel(tabModel);                       // ѡģ
    ui->tableView->setModel(tabModel);                                    // ģ
    ui->tableView->setSelectionModel(theSelection);                       // ѡģ
    ui->tableView->setSelectionBehavior(QAbstractItemView::SelectRows);   // ѡģʽ

    // ӳ,ѡֶӳ䵽ָ༭
    dataMapper= new QDataWidgetMapper();
    dataMapper->setModel(tabModel);
    dataMapper->setSubmitPolicy(QDataWidgetMapper::AutoSubmit);

    dataMapper->addMapping(ui->lineEdit_name,tabModel->fieldIndex("name"));          // ӳֶ
    dataMapper->addMapping(ui->lineEdit_mobile,tabModel->fieldIndex("mobile"));      // ڶӳֶ
    dataMapper->toFirst();                                                           // Ĭѡӳ¼

    // ź,ѡʱ,ڵײ༭
    connect(theSelection,SIGNAL(currentRowChanged(QModelIndex,QModelIndex)),this,SLOT(on_currentRowChanged(QModelIndex,QModelIndex)));
    getFieldNames();
}

MainWindow::~MainWindow()
{
    delete ui;
}

// б,ִлȡname/mobileֶ,ӳݼе lineEdit༭
void MainWindow::on_currentRowChanged(const QModelIndex &current, const QModelIndex &previous)
{
    Q_UNUSED(previous);

    dataMapper->setCurrentIndex(current.row());      // ϸӳк
    int curRecNo=current.row();                      // ȡк
    QSqlRecord  curRec=tabModel->record(curRecNo);   // ȡǰ¼

    QString uname = curRec.value("name").toString();     // ȡ
    QString mobile = curRec.value("mobile").toString();

    ui->lineEdit_name->setText(uname);                   // õ༭
    ui->lineEdit_mobile->setText(mobile);
}

// ȡֶ,ComBox
void MainWindow::getFieldNames()
{
    QSqlRecord emptyRec=tabModel->record();           //ȡռ¼ֶֻ
    for (int i=0;i<emptyRec.count();i++)
    {
        ui->comboBox->addItem(emptyRec.fieldName(i));
    }
}

// һ¼
void MainWindow::on_pushButton_add_clicked()
{
    tabModel->insertRow(tabModel->rowCount(),QModelIndex());                 // ĩβһ¼
    QModelIndex curIndex=tabModel->index(tabModel->rowCount()-1,1);          // һеModelIndex
    theSelection->clearSelection();                                          // ѡ
    theSelection->setCurrentIndex(curIndex,QItemSelectionModel::Select);     // øղΪǰѡ

    int currow=curIndex.row();                                              // õǰ
    tabModel->setData(tabModel->index(currow,0),1000+tabModel->rowCount()); // Զɱ
    tabModel->setData(tabModel->index(currow,2),"M");                       // ĬΪ
    tabModel->setData(tabModel->index(currow,3),"0");                       // Ĭ0
}

// һ¼
void MainWindow::on_pushButton_insert_clicked()
{
    QModelIndex curIndex=ui->tableView->currentIndex();
    int currow=curIndex.row();                                              // õǰ

    tabModel->insertRow(curIndex.row(),QModelIndex());
    tabModel->setData(tabModel->index(currow,0),1000+tabModel->rowCount()); // Զɱ

    theSelection->clearSelection();                                         // ѡ
    theSelection->setCurrentIndex(curIndex,QItemSelectionModel::Select);
}

// ɾһ¼
void MainWindow::on_pushButton_delete_clicked()
{
    QModelIndex curIndex=theSelection->currentIndex();  // ȡǰѡԪģ
    tabModel->removeRow(curIndex.row());                // ɾһ
}

// ޸
void MainWindow::on_pushButton_save_clicked()
{
    bool res=tabModel->submitAll();
    if (res)
    {
        QMessageBox::information(nullptr,"Info","Save Database",QMessageBox::Ok);
    }
}

// ָԭʼ״̬
void MainWindow::on_pushButton_reset_clicked()
{
    tabModel->revertAll();
}

// ComboxеֶζĿ 
void MainWindow::on_pushButton_ascending_clicked()
{
    tabModel->setSort(ui->comboBox->currentIndex(),Qt::AscendingOrder);
    tabModel->select();
}

// ComboxеֶζĿ 
void MainWindow::on_pushButton_descending_clicked()
{
    tabModel->setSort(ui->comboBox->currentIndex(),Qt::DescendingOrder);
    tabModel->select();
}

// ˳м¼
void MainWindow::on_pushButton_filter_man_clicked()
{
    tabModel->setFilter(" sex = 'M' ");
}

// ָĬϹ
void MainWindow::on_pushButton_default_clicked()
{
    tabModel->setFilter("");
}

// ޸
void MainWindow::on_pushButton_clicked()
{
    if (tabModel->rowCount()==0)
        return;

    for (int i=0;i<tabModel->rowCount();i++)
    {
        QSqlRecord aRec=tabModel->record(i);            // ȡǰ¼
        // int uage = aRec.value("age").toFloat();
        aRec.setValue("age",ui->lineEdit->text());      // 
        tabModel->setRecord(i,aRec);
    }
    tabModel->submitAll();                              // ύ޸
}
